#############################
#############################
#############################

install.packages("AER")
library("AER")
data("CASchools")

#############################
#############################
#############################

head(CASchools)
str(CASchools)

data<-CASchools

#district:  District code.
#school: School name.
#county: indicating county.
#grades: factor indicating grade span of district.
#students:Total enrollment.
#teachers: Number of teachers.
#calworks:Percent qualifying for CalWorks (income assistance).
#lunch: Percent qualifying for reduced-price lunch.
#computer: Number of computers.
#expenditure: Expenditure per student.
#income: District average income (in USD 1,000).
#english: Percent of English learners.
#read: Average reading score.
#math: Average math score.

install.packages("car")
library("car")


plot(data$students, data$teachers)

covariance<-function(x,y){
  n<-length(x)
  if(length(x)!=length(y)) return("Error: the arguments x and y have different length")
  res<-sum((x-mean(x))*(y-mean(y)))/n
  return(res)
}

covariance(data$students, data$teachers)
cov(data$students, data$teachers)

### Correlation Analysis

cov(data$students, data$teachers)/(sd(data$students)*sd(data$teachers))

### Descriptive linear regression
x<-data$students
y<-data$math

cor(data$students,data$math)

descriptive_lm<-function(y,x){
b<-cov(x,y)/var(x) 
a<-mean(y-b*x)
tab<-c(a,b)
names(tab)<-c("Intercept", "Slope")
return(tab)
}
descriptive_lm(y,x)
#We get the analougus result with
lm(y ~ x)


plot(x,y)
abline(lm(y ~ x), col = "blue", lwd=2)

###### If we consider also the number of teachers?

x<-data$students/data$teachers
y<-data$math

lm(y ~ x)
cor(x,y)

plot(x,y)
abline(lm(y ~ x), col = "blue", lwd=2)


##### Consider all the variables together ####
cor(data[,-1])

### Better to consider a subset of variables:
cor(data[2:6])
scatterplotMatrix(data[2:6])


#############################
#############################
#############################


data<-read.table("http://archive.ics.uci.edu/ml/machine-learning-databases/wine/wine.data", sep=",")

#############################
#############################
#############################

#These data are the results of a 
#chemical analysis of wines grown 
#in the same region in Italy but 
#derived from three different cultivars.
#The analysis determined the quantities 
#of 13 constituents found in each of 
#the three types of wines. 

#############################
#############################
#############################

names(data)<-c("Class","Alcohol", "Malic acid", "Ash", "Alcalinity of ash", "Magnesium", 
               "Total phenols", "Flavanoids", "Nonflavanoid phenols", "Proanthocyanins", 
               "Color intensity", "Hue",
               "OD280/OD315 of diluted wines",
               "Proline")

# As Excercise you may analyse this dataset!

